# React SDK

## Installation

```bash
# If you use npm:
npm install @context-experiments/react

# Or if you use Yarn:
yarn add @context-experiments/react
```

This module includes [@context-experiments/core](https://www.npmjs.com/package/@context-experiments/core)
as a dependency.

We assume that you're using a module bundler like Parcel, Webpack, or Browserify.
If you don't yet use npm/yarn or a modern module bundler, we don't support
single-file UMD builds yet. We'll add support sometime in the future. Please let
us know if that's something you'd like to see.

## Design

The React SDK has one hook `useFeature`. By thinking of experiments and
rollouts as simply asking, "Is this feature active?" you decouple features from
one another. That minimizes code changes. Here's a list of scenarios, assuming
the feature was originally implemented using:

```javascript
const [isActive, givenValue] = useFeature('my-feature')
```

- Turn the feature on, partially on, or off (No code change)
- Experiment with different values for the same feature (No code change)
- Experiment between the feature and another feature (Code change - Add the
   alternative feature)
- Accept a winning variant (No code change - Turn experiment off, and feature
  on. Removing dead code becomes tech debt.)

## Documentation

We don't yet have comprehensive documentation. We're actively working on it.

## How Does It Work

We don't yet have a comprehensive explainer on how the ReactContext Experiments
SDK works. It is something we're considering for the future.
