"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const context_1 = __importDefault(require("./context"));
const useFeature = (featureReadableId) => {
    const decisionEngine = react_1.useContext(context_1.default);
    try {
        const { isActive, givenValue, variantMetadata } = decisionEngine.isFeatureActive(featureReadableId);
        return [isActive, givenValue, variantMetadata];
    }
    catch (_a) {
        return [false, null, null];
    }
};
exports.default = useFeature;
//# sourceMappingURL=use-feature.js.map